//  
//  For more information, please see: http://software.sci.utah.edu
//  
//  The MIT License
//  
//  Copyright (c) 2004 Scientific Computing and Imaging Institute,
//  University of Utah.
//  
//  License for the specific language governing rights and limitations under
//  Permission is hereby granted, free of charge, to any person obtaining a
//  copy of this software and associated documentation files (the "Software"),
//  to deal in the Software without restriction, including without limitation
//  the rights to use, copy, modify, merge, publish, distribute, sublicense,
//  and/or sell copies of the Software, and to permit persons to whom the
//  Software is furnished to do so, subject to the following conditions:
//  
//  The above copyright notice and this permission notice shall be included
//  in all copies or substantial portions of the Software.
//  
//  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
//  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
//  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
//  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
//  DEALINGS IN THE SOFTWARE.
//  
//    File   : NoData.cc
//    Author : Martin Cole
//    Date   : Mon Aug 23 10:33:51 2004

#include <Core/Basis/NoData.h>

namespace SCIRun {

using std::vector;
using std::string;


NoDataBasis::NoDataBasis() 
{
}

NoDataBasis::~NoDataBasis() 
{
}
  

const string
NoDataBasis::type_name(int n)
{
  static const string nm("NoDataBasis");
  return nm;
}

const int NO_DATA_BASIS_VERSION = 1;

void 
NoDataBasis::io (Piostream& str)
{
  stream.begin_class(get_type_description(this)->get_name(),
                     NO_DATA_BASIS_VERSION);
  stream.end_class();
};


#endif // NoData_h
