/*
   For more information, please see: http://software.sci.utah.edu

   The MIT License

   Copyright (c) 2004 Scientific Computing and Imaging Institute,
   University of Utah.

   License for the specific language governing rights and limitations under
   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included
   in all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
   DEALINGS IN THE SOFTWARE.
*/

#include <Core/CCA/SSIDL/sidl_sidl.h>
#include <Core/Util/NotFinished.h>

using SSIDL::io::Deserializer;
//using SSIDL::io::IOException;

// void .SSIDL.io.Deserializer.Deserializer::unpackBool(in string key, out bool value) throws .SSIDL.io.IOException
void Deserializer::unpackBool(const std::string& key, bool& value)
{
  NOT_FINISHED("void .SSIDL.io.Deserializer.Deserializer::unpackBool(in string key, out bool value) throws .SSIDL.io.IOException");
}

// void .SSIDL.io.Deserializer.Deserializer::unpackChar(in string key, out char value) throws .SSIDL.io.IOException
void Deserializer::unpackChar(const std::string& key, char& value)
{
  NOT_FINISHED("void .SSIDL.io.Deserializer.Deserializer::unpackChar(in string key, out char value) throws .SSIDL.io.IOException");
}

// void .SSIDL.io.Deserializer.Deserializer::unpackInt(in string key, out int value) throws .SSIDL.io.IOException
void Deserializer::unpackInt(const std::string& key, int& value)
{
  NOT_FINISHED("void .SSIDL.io.Deserializer.Deserializer::unpackInt(in string key, out int value) throws .SSIDL.io.IOException");
}

// void .SSIDL.io.Deserializer.Deserializer::unpackLong(in string key, out long value) throws .SSIDL.io.IOException
void Deserializer::unpackLong(const std::string& key, long& value)
{
  NOT_FINISHED("void .SSIDL.io.Deserializer.Deserializer::unpackLong(in string key, out long value) throws .SSIDL.io.IOException");
}

// void .SSIDL.io.Deserializer.Deserializer::unpackOpaque(in string key, out void* value) throws .SSIDL.io.IOException
void Deserializer::unpackOpaque(const std::string& key, void*& value)
{
  NOT_FINISHED("void .SSIDL.io.Deserializer.Deserializer::unpackOpaque(in string key, out void* value) throws .SSIDL.io.IOException");
}

// void .SSIDL.io.Deserializer.Deserializer::unpackFloat(in string key, out float value) throws .SSIDL.io.IOException
void Deserializer::unpackFloat(const std::string& key, float& value)
{
  NOT_FINISHED(" void .SSIDL.io.Deserializer.Deserializer::unpackFloat(in string key, out float value) throws .SSIDL.io.IOException");
}

// void .SSIDL.io.Deserializer.Deserializer::unpackDouble(in string key, out double value) throws .SSIDL.io.IOException
void Deserializer::unpackDouble(const std::string& key, double& value)
{
  NOT_FINISHED("void .SSIDL.io.Deserializer.Deserializer::unpackDouble(in string key, out double value) throws .SSIDL.io.IOException");
}

// void .SSIDL.io.Deserializer.Deserializer::unpackFcomplex(in string key, out complex<float>  value) throws .SSIDL.io.IOException
void Deserializer::unpackFcomplex(const std::string& key, std::complex<float> & value)
{
  NOT_FINISHED("void .SSIDL.io.Deserializer.Deserializer::unpackFcomplex(in string key, out complex<float>  value) throws .SSIDL.io.IOException");
}

// void .SSIDL.io.Deserializer.Deserializer::unpackDcomplex(in string key, out complex<double>  value) throws .SSIDL.io.IOException
void Deserializer::unpackDcomplex(const std::string& key, std::complex<double> & value)
{
  NOT_FINISHED("void .SSIDL.io.Deserializer.Deserializer::unpackDcomplex(in string key, out complex<double>  value) throws .SSIDL.io.IOException");
}

// void .SSIDL.io.Deserializer.Deserializer::unpackString(in string key, out string value) throws .SSIDL.io.IOException
void Deserializer::unpackString(const std::string& key, std::string& value)
{
  NOT_FINISHED("void .SSIDL.io.Deserializer.Deserializer::unpackString(in string key, out string value) throws .SSIDL.io.IOException");
}

// void .SSIDL.io.Deserializer.Deserializer::unpackSerializable(in string key, out .SSIDL.io.Serializable value) throws .SSIDL.io.IOException
void Deserializer::unpackSerializable(const std::string& key, Serializable::pointer& value)
{
  NOT_FINISHED("void .SSIDL.io.Deserializer.Deserializer::unpackSerializable(in string key, out .SSIDL.io.Serializable value) throws .SSIDL.io.IOException");
}

// void .SSIDL.io.Deserializer.Deserializer::unpackBoolArray(in string key, out array1< bool, 1> value, in int ordering, in int dimen, in bool isRarray) throws .SSIDL.io.IOException
void Deserializer::unpackBoolArray(const std::string& key, ::SSIDL::array1< bool>& value, int ordering, int dimen, bool isRarray)
{
  NOT_FINISHED("void .SSIDL.io.Deserializer.Deserializer::unpackBoolArray(in string key, out array1< bool, 1> value, in int ordering, in int dimen, in bool isRarray) throws .SSIDL.io.IOException");
}

// void .SSIDL.io.Deserializer.Deserializer::unpackCharArray(in string key, out array1< char, 1> value, in int ordering, in int dimen, in bool isRarray) throws .SSIDL.io.IOException
void Deserializer::unpackCharArray(const std::string& key, ::SSIDL::array1< char>& value, int ordering, int dimen, bool isRarray)
{
  NOT_FINISHED("void .SSIDL.io.Deserializer.Deserializer::unpackCharArray(in string key, out array1< char, 1> value, in int ordering, in int dimen, in bool isRarray) throws .SSIDL.io.IOException");
}

// void .SSIDL.io.Deserializer.Deserializer::unpackIntArray(in string key, out array1< int, 1> value, in int ordering, in int dimen, in bool isRarray) throws .SSIDL.io.IOException
void Deserializer::unpackIntArray(const std::string& key, ::SSIDL::array1< int>& value, int ordering, int dimen, bool isRarray)
{
  NOT_FINISHED("void .SSIDL.io.Deserializer.Deserializer::unpackIntArray(in string key, out array1< int, 1> value, in int ordering, in int dimen, in bool isRarray) throws .SSIDL.io.IOException");
}

// void .SSIDL.io.Deserializer.Deserializer::unpackLongArray(in string key, out array1< long, 1> value, in int ordering, in int dimen, in bool isRarray) throws .SSIDL.io.IOException
void Deserializer::unpackLongArray(const std::string& key, ::SSIDL::array1< long>& value, int ordering, int dimen, bool isRarray)
{
  NOT_FINISHED("void .SSIDL.io.Deserializer.Deserializer::unpackLongArray(in string key, out array1< long, 1> value, in int ordering, in int dimen, in bool isRarray) throws .SSIDL.io.IOException");
}

// void .SSIDL.io.Deserializer.Deserializer::unpackOpaqueArray(in string key, out array1< void*, 1> value, in int ordering, in int dimen, in bool isRarray) throws .SSIDL.io.IOException
void Deserializer::unpackOpaqueArray(const std::string& key, ::SSIDL::array1< void*>& value, int ordering, int dimen, bool isRarray)
{
  NOT_FINISHED("void .SSIDL.io.Deserializer.Deserializer::unpackOpaqueArray(in string key, out array1< void*, 1> value, in int ordering, in int dimen, in bool isRarray) throws .SSIDL.io.IOException");
}

// void .SSIDL.io.Deserializer.Deserializer::unpackFloatArray(in string key, out array1< float, 1> value, in int ordering, in int dimen, in bool isRarray) throws .SSIDL.io.IOException
void Deserializer::unpackFloatArray(const std::string& key, ::SSIDL::array1< float>& value, int ordering, int dimen, bool isRarray)
{
  NOT_FINISHED("void .SSIDL.io.Deserializer.Deserializer::unpackFloatArray(in string key, out array1< float, 1> value, in int ordering, in int dimen, in bool isRarray) throws .SSIDL.io.IOException");
}

// void .SSIDL.io.Deserializer.Deserializer::unpackDoubleArray(in string key, out array1< double, 1> value, in int ordering, in int dimen, in bool isRarray) throws .SSIDL.io.IOException
void Deserializer::unpackDoubleArray(const std::string& key, ::SSIDL::array1< double>& value, int ordering, int dimen, bool isRarray)
{
  NOT_FINISHED("void .SSIDL.io.Deserializer.Deserializer::unpackDoubleArray(in string key, out array1< double, 1> value, in int ordering, in int dimen, in bool isRarray) throws .SSIDL.io.IOException");
}

// void .SSIDL.io.Deserializer.Deserializer::unpackFcomplexArray(in string key, out array1< complex<float> , 1> value, in int ordering, in int dimen, in bool isRarray) throws .SSIDL.io.IOException
void Deserializer::unpackFcomplexArray(const std::string& key, ::SSIDL::array1< std::complex<float> >& value, int ordering, int dimen, bool isRarray)
{
  NOT_FINISHED("void .SSIDL.io.Deserializer.Deserializer::unpackFcomplexArray(in string key, out array1< complex<float> , 1> value, in int ordering, in int dimen, in bool isRarray) throws .SSIDL.io.IOExceptio");
}

// void .SSIDL.io.Deserializer.Deserializer::unpackDcomplexArray(in string key, out array1< complex<double> , 1> value, in int ordering, in int dimen, in bool isRarray) throws .SSIDL.io.IOException
void Deserializer::unpackDcomplexArray(const std::string& key, ::SSIDL::array1< std::complex<double> >& value, int ordering, int dimen, bool isRarray)
{
  NOT_FINISHED("void .SSIDL.io.Deserializer.Deserializer::unpackDcomplexArray(in string key, out array1< complex<double> , 1> value, in int ordering, in int dimen, in bool isRarray) throws .SSIDL.io.IOException");
}

// void .SSIDL.io.Deserializer.Deserializer::unpackStringArray(in string key, out array1< string, 1> value, in int ordering, in int dimen, in bool isRarray) throws .SSIDL.io.IOException
void Deserializer::unpackStringArray(const std::string& key, ::SSIDL::array1< std::string>& value, int ordering, int dimen, bool isRarray)
{
  NOT_FINISHED("void .SSIDL.io.Deserializer.Deserializer::unpackStringArray(in string key, out array1< string, 1> value, in int ordering, in int dimen, in bool isRarray) throws .SSIDL.io.IOException");
}

// void .SSIDL.io.Deserializer.Deserializer::unpackSerializableArray(in string key, out array1< .SSIDL.io.Serializable, 1> value, in int ordering, in int dimen, in bool isRarray) throws .SSIDL.io.IOException
void Deserializer::unpackSerializableArray(const std::string& key, ::SSIDL::array1< SSIDL::io::Serializable::pointer >& value, int ordering, int dimen, bool isRarray)
{
  NOT_FINISHED("void .SSIDL.io.Deserializer.Deserializer::unpackSerializableArray(in string key, out array1< .SSIDL.io.Serializable, 1> value, in int ordering, in int dimen, in bool isRarray) throws .SSIDL.io.IOException");
}
