#
#  For more information, please see: http://software.sci.utah.edu
# 
#  The MIT License
# 
#  Copyright (c) 2004 Scientific Computing and Imaging Institute,
#  University of Utah.
# 
#  License for the specific language governing rights and limitations under
#  Permission is hereby granted, free of charge, to any person obtaining a
#  copy of this software and associated documentation files (the "Software"),
#  to deal in the Software without restriction, including without limitation
#  the rights to use, copy, modify, merge, publish, distribute, sublicense,
#  and/or sell copies of the Software, and to permit persons to whom the
#  Software is furnished to do so, subject to the following conditions:
# 
#  The above copyright notice and this permission notice shall be included
#  in all copies or substantial portions of the Software.
# 
#  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
#  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
#  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
#  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
#  DEALINGS IN THE SOFTWARE.
#


SRCDIR   := Framework/Babel
FWKSIDL := ${SRCDIR}/framework.sidl

#OUTPUTDIR :=${SRCTOP_ABS}/$(SRCDIR)
OUTPUTDIR :=${OBJTOP_ABS}/$(SRCDIR)

INCLUDES := -I$(OUTPUTDIR) $(INCLUDES)

ifeq ($(IS_OSX),yes)
  CP_FLAGS :=
else
  CP_FLAGS := -u
endif

${OUTPUTDIR}/framework.make: ${FWKSIDL} Core/Babel/timestamp
	if ! test -d $(dir $@); then mkdir -p $(dir $@); fi
	cp $(CP_FLAGS) $(dir $<)*Impl.* $(dir $@)
	$(BABEL) --server=C++ --output-directory=$(dir $@) --repository-path=${BABEL_REPOSITORY} $<
	mv $(dir $@)babel.make $@

${OUTPUTDIR}/cca.make: ${CCASIDL}
	$(BABEL) --client=C++ --output-directory=${dir $@} $<
	mv $(dir $@)babel.make $@

SRCS := $(SRCS) $(SRCDIR)/BabelComponentModel.cc \
        $(SRCDIR)/BabelComponentInstance.cc \
        $(SRCDIR)/BabelComponentDescription.cc \
        $(SRCDIR)/BabelPortInstance.cc

IORSRCS :=
STUBSRCS :=
IMPLSRCS :=
SKELSRCS :=
include ${OUTPUTDIR}/framework.make
SRCS := $(SRCS) $(patsubst %,$(SRCDIR)/%,$(IORSRCS) $(STUBSRCS) $(IMPLSRCS) $(SKELSRCS))

IORSRCS :=
STUBSRCS :=
IMPLSRCS :=
SKELSRCS :=
include ${OUTPUTDIR}/cca.make
SRCS := $(SRCS) $(patsubst %,$(SRCDIR)/%,$(IORSRCS) $(STUBSRCS) $(IMPLSRCS) $(SKELSRCS))
