#
#  For more information, please see: http://software.sci.utah.edu
# 
#  The MIT License
# 
#  Copyright (c) 2004 Scientific Computing and Imaging Institute,
#  University of Utah.
# 
#  License for the specific language governing rights and limitations under
#  Permission is hereby granted, free of charge, to any person obtaining a
#  copy of this software and associated documentation files (the "Software"),
#  to deal in the Software without restriction, including without limitation
#  the rights to use, copy, modify, merge, publish, distribute, sublicense,
#  and/or sell copies of the Software, and to permit persons to whom the
#  Software is furnished to do so, subject to the following conditions:
# 
#  The above copyright notice and this permission notice shall be included
#  in all copies or substantial portions of the Software.
# 
#  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
#  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
#  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
#  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
#  DEALINGS IN THE SOFTWARE.
#


# GUI for IsoValueController module
# by Allen R. Sanderson
# August 2004

catch {rename Fusion_Fields_IsoValueController ""}

itcl_class Fusion_Fields_IsoValueController {
    inherit Module
    constructor {config} {
        set name IsoValueController
        set_defaults
    }

    method set_defaults {} {

	global $this-isovalues
	set $this-isovalues "0.0"
    }

    method ui {} {
        set w .ui[modname]
        if {[winfo exists $w]} {
            raise $w
            return
        }

	toplevel $w

	frame $w.isolist
	label $w.isolist.l -text "List of Isovals:"
	entry $w.isolist.e -width 40 -text $this-isovalues
	bind $w.isolist.e <Return> "$this-c needexecute"
	pack $w.isolist.l $w.isolist.e -side left -fill both -expand 1
	pack $w.isolist -fill x

	makeSciButtonPanel $w $w $this
	moveToCursor $w
    }
}
