#  For more information, please see: http://software.sci.utah.edu
# 
#  The MIT License
# 
#  Copyright (c) 2004 Scientific Computing and Imaging Institute,
#  University of Utah.
# 
#  License for the specific language governing rights and limitations under
#  Permission is hereby granted, free of charge, to any person obtaining a
#  copy of this software and associated documentation files (the "Software"),
#  to deal in the Software without restriction, including without limitation
#  the rights to use, copy, modify, merge, publish, distribute, sublicense,
#  and/or sell copies of the Software, and to permit persons to whom the
#  Software is furnished to do so, subject to the following conditions:
# 
#  The above copyright notice and this permission notice shall be included
#  in all copies or substantial portions of the Software.
# 
#  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
#  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
#  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
#  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
#  DEALINGS IN THE SOFTWARE.
#

#    File   : TendAnhist.tcl
#    Author : Darby Van Uitert
#    Date   : April 2004

itcl_class Teem_Tend_TendAnhist {
    inherit Module

    constructor {config} {
        set name TendAnhist
    }

    method set_defaults {} {
	global $this-right
	set $this-right 0

	global $this-westin
	set $this-westin 1

	global $this-resolution
	set $this-resolution 256
    }

    method ui {} {
        set w .ui[modname]
        if {[winfo exists $w]} {
            return
        }
        toplevel $w

        frame $w.f
	pack $w.f -padx 2 -pady 2 -side top -expand yes
	
	frame $w.f.options
	pack $w.f.options -side top -expand yes
	
	checkbutton $w.f.options.right \
	    -text "Sample a right-triangle-shaped region, instead of a roughly equilateral triangle." \
	    -variable $this-right

	radiobutton $w.f.options.westin1 \
	    -text "Version 1 of Westin's Anisotropy Metric Triple" \
	    -variable $this-westin \
	    -value 1

	radiobutton $w.f.options.westin2 \
	    -text "Version 2 of Westin's Anisotropy Metric Triple" \
	    -variable $this-westin \
	    -value 2

        pack $w.f.options.right \
	    $w.f.options.westin1 $w.f.options.westin2 \
	    -side top -expand yes -fill x
	

        iwidgets::entryfield $w.f.options.resolution \
	    -labeltext "Resolution:" \
	    -textvariable $this-resolution
        pack $w.f.options.resolution -side top -expand yes -fill x

	makeSciButtonPanel $w.f $w $this
	moveToCursor $w

	pack $w.f -expand 1 -fill x
    }
}


