/*
   For more information, please see: http://software.sci.utah.edu

   The MIT License

   Copyright (c) 2004 Scientific Computing and Imaging Institute,
   University of Utah.

   License for the specific language governing rights and limitations under
   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included
   in all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
   DEALINGS IN THE SOFTWARE.
*/



#ifndef CCA_h
#define CCA_h

#include <Core/Thread/Thread.h>
#include <testprograms/Component/framework/cca_sidl.h>
#include <testprograms/Component/framework/FrameworkImpl.h>

#include <string>

namespace SCIRun {
class Thread;
}

namespace sci_cca {

using namespace SCIRun;

using std::string;

class Server;

class CCA {

public:
  static bool init( int &argc, char *argv[] );
  static bool init ( Component::pointer& component, 
		     const string& component_name = "" );
  static void done();

private:
  static bool       initialized_;
  static Framework::pointer  framework_;
  static string     framework_url_;
  static Thread   * framework_thread_;
  static bool       is_server_;
  static Component::pointer  local_framework_;
  static string     hostname_;
  static string     program_;
  static Semaphore  semaphore_;

  CCA(); // you can not allocate a CCA

  friend class Server;
};



} // namespace sci_cca

#endif // CCA_h
